package be.tryalogue;

import android.content.Context;
import android.content.res.Resources;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.util.AttributeSet;
import android.view.SurfaceHolder;
import android.view.SurfaceView;

public class OscilloscopeAnimation extends SurfaceView implements SurfaceHolder.Callback {
	  
	AnimationThread animationThread;


	public OscilloscopeAnimation(Context context, AttributeSet attrs) {
		this(context, attrs,0);
		// TODO Auto-generated constructor stub
	}
	
	public OscilloscopeAnimation(Context context) {
		this(context,null,0);
		
		
	}
	public OscilloscopeAnimation(Context context, AttributeSet attrs,
			int defStyle) {
		super(context, attrs, defStyle);
		getHolder().addCallback(this);
		 Resources res = context.getResources();
		// TODO Auto-generated constructor stub
		mBackgroundImage = BitmapFactory.decodeResource(res,R.drawable.microphone);
		animationThread = new AnimationThread(getHolder(), this);
	}

	Bitmap mBackgroundImage;
	


	@Override
	public void surfaceChanged(SurfaceHolder holder, int format, int width,
			int height) {
		mBackgroundImage = Bitmap.createScaledBitmap(mBackgroundImage, width, height, true);
		
	}

	@Override
	public void surfaceCreated(SurfaceHolder holder) {
		Canvas c = getHolder().lockCanvas();
	    draw(c);
	    getHolder().unlockCanvasAndPost(c);
		 animationThread.setRunning(true);
		 animationThread.start();
		
	}

	@Override
	public void surfaceDestroyed(SurfaceHolder holder) {
		boolean retry = true;
        animationThread.setRunning(false);
        while (retry) {
            try {
                animationThread.join();
                retry = false;
            } catch (InterruptedException e) {
                // we will try it again and again...
            }
        }
		
	}
	
	Paint paint = new Paint();

	@Override
	public void onDraw(Canvas canvas) {
		// Draw the background image. Operations on the Canvas accumulate
		// so this is like clearing the screen.
		canvas.drawBitmap(mBackgroundImage, 0, 0, null);
		
		if(currentRmsdB != 0){
			float halfwidth = getWidth()/2;
			paint.setColor(Color.LTGRAY);
			currentRmsdB = Math.abs(currentRmsdB);
			paint.setColor(Color.GRAY);
			canvas.drawRect(halfwidth - currentRmsdB * 2, 20, halfwidth + currentRmsdB * 2, 50, paint);
			
			canvas.drawLine(halfwidth, 15, halfwidth, 55, paint);
		}

	
		
		
	}



	public void setBytes(byte[] buffer) {

	}
	 
	 
	 static class AnimationThread extends Thread {
	        private SurfaceHolder _surfaceHolder;
	        private OscilloscopeAnimation _panel;
	        private boolean _run = false;
	 
	        public AnimationThread(SurfaceHolder surfaceHolder, OscilloscopeAnimation panel) {
	            _surfaceHolder = surfaceHolder;
	            _panel = panel;
	        }
	 
	        public void setRunning(boolean run) {
	            _run = run;
	        }
	 
	        @Override
	        public void run() {
	            Canvas c;
	            while (_run) {
	                c = null;
	                try {
	                    c = _surfaceHolder.lockCanvas(null);
	                    synchronized (_surfaceHolder) {
	                        _panel.onDraw(c);
	                    }
	                } finally {
	                    // do this in a finally so that if an exception is thrown
	                    // during the above, we don't leave the Surface in an
	                    // inconsistent state
	                    if (c != null) {
	                        _surfaceHolder.unlockCanvasAndPost(c);
	                    }
	                }
	            }
	        }
	    }


	float currentRmsdB;
	public void setRmsDB(float rmsdB) {
		currentRmsdB = rmsdB;
		
	}


}
